#include "forms.h"
#include "color.h"
#include "color_defs.h"
#include <math.h>


void init(void)
{
  redcol=FL_FREE_COL1;
  greencol=FL_FREE_COL2;
  bluecol=FL_FREE_COL3;

  fl_addto_form(colorform);
  freeobj = obj = fl_add_free(FL_NORMAL_FREE,130,40,310,300, "", freeobject_handler);
  fl_set_object_gravity(obj,FL_NorthWest,FL_SouthEast);
  fl_end_form();
   
  fl_set_object_dblbuffer(freeobj,1);
  fl_mapcolor(FL_FREE_COL1,fl_get_slider_value(red),0,0);
  fl_mapcolor(FL_FREE_COL2,0,fl_get_slider_value(green),0);
  fl_mapcolor(FL_FREE_COL3,0,0,fl_get_slider_value(blue)); 
  fl_redraw_object(freeobj); 
}

int freeobject_handler(FL_OBJECT * ob, int event, FL_Coord mx, FL_Coord my,
		   int key, void *xev)
{
    int x, y, w, h, r, tmp; 

    tmp=fl_get_drawmode();
    switch (event)
    {
    case FL_DRAW:
        x=scherm->x;
        y=scherm->y;
        w=scherm->w;
        h=scherm->h;
        fl_rectf(0,0,w,h,FL_BLACK);
        fl_drawmode(GXor);
        if (h<w) r=floor((h-20)/3); else r=floor((w-20)/3);
        fl_ovalf(floor(w/2-r),h/2-1.43*r,2*r,2*r,FL_FREE_COL1);
        fl_ovalf(w/2-1.5*r,h/2-r+0.43*r,2*r,2*r,FL_FREE_COL2);
        fl_ovalf(w/2-0.5*r,h/2-r+0.43*r,2*r,2*r,FL_FREE_COL3);   
        break;
    }
    fl_drawmode(tmp);
    return 0;
}

void color(FL_OBJECT *ob, long data)
{
  switch (data)
  {
   case 1 :  // red slider
           fl_mapcolor(FL_FREE_COL1,fl_get_slider_value(ob),0,0);
           break;
   case 2 :  // green slider
           fl_mapcolor(FL_FREE_COL2,0,fl_get_slider_value(ob),0);
           break;
   case 3 :  // blue slider
           fl_mapcolor(FL_FREE_COL3,0,0,fl_get_slider_value(ob)); 
           break;               
  } 

  fl_redraw_object(freeobj); 
}



